#!/bin/sh
#
#       contrast - compare files token by token
#       Copyright (C) 2006, 2009 Peter Miller
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or (at
# you option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program. If not, see <http://www.gnu.org/licenses/>
#
unset LANGUAGE
unset LC_ALL
LANG=C
export LANG
cat << 'fubar'
<html>
<body>
<h1>
<img src="icon64.png" align=left>
<img src="icon64.png" align=right>
<center>Source Code Size</center></h1>
The information on this page is produced by the <i>sloccount</i> program
by David A. Wheeler <dwheeler@dwheeler.com>.
<p>
For more information see the SLOCCount website
at <a href="http://www.dwheeler.com/sloccount.">
http://www.dwheeler.com/sloccount</a>.  Note that more detailed
documentation is available both on the website and with the SLOCCount
package.
<pre>
fubar

here=`pwd`
test $? -eq 0 || exit 1

temp=/tmp/$$
mkdir $temp
test $? -eq 0 || exit 1

fail() {
    cd $here
    rm -rf $temp
    exit 1
}

trap "fail" 1 2 3 15

HOME=$temp
export HOME

( cd $temp ; sloccount "$@" ) | sed '1,/Computing results/d' > $temp/out.txt
if test ! -s $temp/out.txt
then
    echo ""
    echo "sloccount produced nothing" 1>&2
    echo ""
    fail
fi
cat $temp/out.txt
rm -rf $temp

echo '</pre>'
echo 'This page last updated'
date
echo '</body></html>'
exit 0
