//
//      contrast - compare files token by token
//      Copyright (C) 2009 Peter Miller
//
//      This program is free software; you can redistribute it and/or
//      modify it under the terms of the GNU General Public License,
//      version 3, as published by the Free Software Foundation.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program. If not, see
//      <http://www.gnu.org/licenses/>.
//

#ifndef LIB_IS_REGULAR_FILE_H
#define LIB_IS_REGULAR_FILE_H

#include <lib/rcstring.h>

/**
  * The is_regular_file function is used to test a path to see if it
  * exists and is a regular file.
  *
  * @param path
  *     The file path to be tested.
  * @returns
  *     true if the path exists and is a regular file, false if the path
  *     does not exists, false if the file exists but is not a regular
  *     file.
  */
bool is_regular_file(const rcstring &path);

#endif // LIB_IS_REGULAR_FILE_H
