//
//      example-c-plus-plus - an example Aegis project
//      Copyright (C) 2006, 2009, 2010 Peter Miller
//
//      This program is free software; you can redistribute it and/or
//      modify it under the terms of the GNU General Public License,
//      version 3, as published by the Free Software Foundation.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program. If not, see
//      <http://www.gnu.org/licenses/>.
//

#include <lib/rcstring/list.h>


void
rcstring_list::push_back(const rcstring &w)
{
    if (nstrings >= nstrings_max)
    {
        //
        // always 8 less than a power of 2, which is
        // most efficient for many memory allocators
        //
        size_t new_nstrings_max = nstrings_max * 2 + 8;
        rcstring *new_string = new rcstring[new_nstrings_max];
        for (size_t j = 0; j < nstrings; ++j)
            new_string[j] = string[j];
        delete [] string;
        string = new_string;
        nstrings_max = new_nstrings_max;
    }
    string[nstrings++] = w;
}
