//
//      example-c-plus-plus - an example Aegis project
//      Copyright (C) 2006, 2009, 2010 Peter Miller
//
//      This program is free software; you can redistribute it and/or
//      modify it under the terms of the GNU General Public License,
//      version 3, as published by the Free Software Foundation.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program. If not, see
//      <http://www.gnu.org/licenses/>.
//

#include <cstring>
#include <lib/rcstring/accumulator.h>
#include <lib/rcstring/list.h>


rcstring
rcstring_list::unsplit(const char *sep)
    const
{
    return unsplit(0, size(), sep);
}


rcstring
rcstring_list::unsplit(size_t start, size_t stop, const char *sep)
    const
{
    if (!sep)
        sep = " ";
    size_t seplen = strlen(sep);

    static rcstring_accumulator tmp;
    tmp.clear();
    for (size_t j = start; j <= stop && j < nstrings; j++)
    {
        const rcstring &s = string[j];
        if (s.size())
        {
            tmp.push_back(sep, seplen);
            tmp.push_back(s);
        }
    }

    return tmp.mkstr();
}
