//
//      contrast - compare files token by token
//      Copyright (C) 2006, 2009 Peter Miller
//
//      This program is free software; you can redistribute it and/or
//      modify it under the terms of the GNU General Public License,
//      version 3, as published by the Free Software Foundation.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program. If not, see
//      <http://www.gnu.org/licenses/>.
//

#ifndef LIB_SOURCE_GENERIC_H
#define LIB_SOURCE_GENERIC_H

#include <lib/source.h>

/**
  * The source_generic class is used to represent a generic input
  * source, separated into words, punctuation and white space.
  */
class source_generic:
    public source
{
public:
    /**
      * The destructor.
      */
    virtual ~source_generic();

    /**
      * The constructor.
      */
    source_generic(const rcstring &filename);

protected:
    // See base class for documentation.
    type_t get_next_token(rcstring &value);

private:
    /**
      * The default constructor.  Do not use.
      */
    source_generic();

    /**
      * The copy constructor.  Do not use.
      */
    source_generic(const source_generic &);

    /**
      * The assignment operator.  Do not use.
      */
    source_generic &operator=(const source_generic &);
};

#endif // LIB_SOURCE_GENERIC_H
