//
//      example-c-plus-plus - an example Aegis project
//      Copyright (C) 2006, 2009 Peter Miller
//
//      This program is free software; you can redistribute it and/or
//      modify it under the terms of the GNU General Public License,
//      version 3, as published by the Free Software Foundation.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program. If not, see
//      <http://www.gnu.org/licenses/>.
//

#include <lib/symtab.h>


symtab_base::symtab_base(int suggested_size) :
    reap(0),
    hash_table(0),
    hash_modulus(0),
    hash_mask(0),
    hash_load(0)
{
    hash_modulus = 1 << 5; // MUST be a power of 2
    while ((long)hash_modulus < (long)suggested_size)
        hash_modulus <<= 1;
    hash_mask = hash_modulus - 1;
    hash_table = new row_t * [hash_modulus];
    for (hash_t j = 0; j < hash_modulus; ++j)
        hash_table[j] = 0;
}


symtab_base::~symtab_base()
{
    clear();

    reap = 0;
    delete [] hash_table;
    hash_table = 0;
    hash_modulus = 0;
    hash_mask = 0;
}


symtab_base::row_t::~row_t()
{
    data = 0;
    overflow = 0;
}


symtab_base::row_t::row_t() :
    data(0),
    overflow(0)
{
}
