//
//      contrast - compare files token by token
//      Copyright (C) 2006, 2009 Peter Miller
//
//      This program is free software; you can redistribute it and/or
//      modify it under the terms of the GNU General Public License,
//      version 3, as published by the Free Software Foundation.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program. If not, see
//      <http://www.gnu.org/licenses/>.
//

#include <cstdio>

#include <lib/token.h>


token::~token()
{
}


token::token()
{
}


token::token(const rcstring &a_white, const rcstring &a_ink) :
    white(a_white),
    ink(a_ink)
{
}


token::token(const token &arg) :
    white(arg.white),
    ink(arg.ink)
{
}


token &
token::operator=(const token &arg)
{
    if (this != &arg)
    {
        white = arg.white;
        ink = arg.ink;
    }
    return *this;
}


void
token::print()
    const
{
    fwrite(white.c_str(), white.size(), 1, stdout);
    fwrite(ink.c_str(), ink.size(), 1, stdout);
}


rcstring
token::representation()
    const
{
    return
        rcstring::printf
        (
            "{ white = %s; ink = %s; }",
            white.quote_c().c_str(),
            ink.quote_c().c_str()
        );
}
