//
//      contrast - compare files token by token
//      Copyright (C) 2006, 2009 Peter Miller
//
//      This program is free software; you can redistribute it and/or
//      modify it under the terms of the GNU General Public License,
//      version 3, as published by the Free Software Foundation.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program. If not, see
//      <http://www.gnu.org/licenses/>.
//

#include <lib/token/list.h>


token_list::~token_list()
{
    delete [] item;
    item = 0;
    length = 0;
    maximum = 0;
}


token_list::token_list() :
    item(0),
    length(0),
    maximum(0)
{
}


void
token_list::push_back(const rcstring &ink, const rcstring &white)
{
    if (length >= maximum)
    {
        size_t new_maximum = maximum * 2 + 16;
        token *new_item = new token [new_maximum];
        for (size_t j = 0; j < length; ++j)
            new_item[j] = item[j];
        delete [] item;
        item = new_item;
        maximum = new_maximum;
    }
    item[length++] = token(ink, white);
}
