//
//      aegis - project change supervisor
//      Copyright (C) 2004, 2005, 2009, 2010 Peter Miller;
//      All rights reserved.
//
//      This program is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; either version 3 of the License, or
//      (at your option) any later version.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program. If not, see
//      <http://www.gnu.org/licenses/>.
//

#include <lib/fstrcmp.h>
#include <lib/symtab.h>


rcstring
symtab_base::query_fuzzy(const rcstring &key)
    const
{
    rcstring best_name = key;
    double best_weight = 0.6;
    for (hash_t index = 0; index < hash_modulus; ++index)
    {
        for (row_t *p = hash_table[index]; p; p = p->overflow)
        {
            double weight = fstrcmp(key.c_str(), p->key.c_str());
            if (weight > best_weight)
                best_name = p->key;
        }
    }
    return best_name;
}
